#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

#define MAX 100
#define FAJL "proizvodi.dat"
#define IZVESTAJ "izvestaj.txt"

typedef struct proizvod {
	char naziv[50];
	double cena;
}PROIZVOD;

typedef struct cvor *PCVOR;

typedef struct cvor {
	PROIZVOD podatak;
	PCVOR sledeci;
}CVOR;

void meni(void);
PROIZVOD unos_proizvoda();
void dodaj_proizvod_niz(PROIZVOD niz[], int *n, PROIZVOD p);
void stampaj_proizvod(PROIZVOD p);
void prikaz_proizvoda_niz(PROIZVOD niz[], int n);
void sacuvaj_proizvode(char naziv_dat[], PROIZVOD niz[], int n);
void dodaj_proizvod_lista(PCVOR *glava, PROIZVOD p);
void ucitaj_proizvode_lista(char naziv_dat[], PCVOR *glava);
void prikaz_proizvoda_lista(PCVOR glava);
void formiraj_izvestaj(char naziv_dat[], PCVOR glava, double iznos);

int main(void) {
	meni();
	return 0;
}

void meni(void) {
	int izbor;
	double iznos;
	PROIZVOD niz[MAX];
	int n = 0; // Na pocetku je niz proizvoda prazan
	PROIZVOD p;
	PCVOR glava = NULL; // Na pocetku je lista prazna
	do {
		printf("*** Meni A7 ***\n");
		printf("1. Unos proizvoda u niz\n");
		printf("2. Prikaz proizvoda iz niza\n");
		printf("3. Cuvanje niza proizvoda u binarnoj datoteci\n");
		printf("4. Ucitavanje proizvoda iz binarne datoteke\n");
		printf("5. Prikaz proizvoda iz liste\n");
		printf("6. Izvestaj\n");
		printf("7. Kraj rada\n");
		printf("Vas izbor (1-7): ");
		scanf("%d", &izbor);
		getchar();
		switch (izbor) {
		case 1:
			p = unos_proizvoda();
			dodaj_proizvod_niz(niz, &n, p);
			break;
		case 2:
			prikaz_proizvoda_niz(niz, n);
			break;
		case 3:
			sacuvaj_proizvode(FAJL, niz, n);
			break;
		case 4:
			ucitaj_proizvode_lista(FAJL, &glava);
			break;
		case 5:
			prikaz_proizvoda_lista(glava);
			break;
		case 6:
			printf("Unesite iznos: ");
			scanf("%lf", &iznos);
			getchar();
			formiraj_izvestaj(IZVESTAJ, glava, iznos);
			break;
		case 7:
			printf("Kraj programa - dovidjenja!\n");
			break;
		default:
			printf("Nepostojeci unos\n");
			break;
		}
	} while (izbor != 7);
}

PROIZVOD unos_proizvoda() {
	PROIZVOD p;
	printf("Unesite naziv: ");
	gets(p.naziv);
	printf("Unesite cenu: ");
	scanf("%lf", &p.cena);
	getchar();
	return p;
}

void dodaj_proizvod_niz(PROIZVOD niz[], int *n, PROIZVOD p) {
	niz[*n] = p;
	*n = *n + 1;
}

void stampaj_proizvod(PROIZVOD p) {
	printf("%30s%10.2lf\n", p.naziv, p.cena);
}

void prikaz_proizvoda_niz(PROIZVOD niz[], int n) {
	int i = 0;
	printf("*** PROIZVODI ***\n");
	while (i < n) {
		stampaj_proizvod(niz[i]);
		i++;
	}
}

void sacuvaj_proizvode(char naziv_dat[], PROIZVOD niz[], int n) {
	int i;
	FILE *datoteka = fopen(naziv_dat, "wb");
	if (datoteka == NULL) {
		printf("Datoteka nije kreirana!\n");
		return;
	}
	// Prvi nacin - upis celog niza
	fwrite(niz, sizeof(PROIZVOD), n, datoteka);

	// Drugi nacin - upis jednog po jednog elementa
	//for (i = 0; i < n; i++) {
	//	fwrite(&niz[i], sizeof(PROIZVOD), 1, datoteka);
	//}
	fclose(datoteka);
}

void dodaj_proizvod_lista(PCVOR *glava, PROIZVOD p) {
	// Komentar: na osnovu teksta zadatka zakljucili smo da je potrebno ubacivati elemente na pocetak liste
	PCVOR novi = malloc(sizeof(CVOR));
	novi->podatak = p;
	novi->sledeci = *glava;
	*glava = novi;
}

void ucitaj_proizvode_lista(char naziv_dat[], PCVOR *glava) {
	PROIZVOD p;
	FILE *datoteka = fopen(naziv_dat, "rb");
	if (datoteka == NULL) {
		printf("Datoteka ne postoji!\n");
		return;
	}
	while (fread(&p, sizeof(PROIZVOD), 1, datoteka) > 0) {
		dodaj_proizvod_lista(glava, p);
		//stampaj_proizvod(p);
	}
	fclose(datoteka);
}

void prikaz_proizvoda_lista(PCVOR glava) {
	PCVOR tekuci = glava;
	while (tekuci != NULL) {
		stampaj_proizvod(tekuci->podatak);
		tekuci = tekuci->sledeci;
	}
}

void formiraj_izvestaj(char naziv_dat[], PCVOR glava, double iznos) {
	double suma = 0;
	int brojac = 0;
	FILE *datoteka = fopen(naziv_dat, "w");
	if (datoteka == NULL) {
		printf("Datoteka ne postoji!\n");
		return;
	}
	fprintf(datoteka, "%30s%9s\n", "Naziv", "Cena");
	fprintf(datoteka, "%s\n", "=======================================");
	while (glava != NULL) {
		if (glava->podatak.cena > iznos) {
			// Ovaj proizvod treba ukljuciti u izvestaj
			suma += glava->podatak.cena;
			brojac++;
			fprintf(datoteka, "%30s%10.2lf\n", glava->podatak.naziv, glava->podatak.cena);
		}
		glava = glava->sledeci;
	}
	fprintf(datoteka, "%s", "\n\n");
	if (brojac > 0) {
		fprintf(datoteka, "%s: %.2lf\n", "PROSEK", suma / brojac);
	}
	else {
		fprintf(datoteka, "%s\n", "Nema proizvoda cija cena zadovoljava kriterijum.");
	}
	fclose(datoteka);
}